# Calendar

## Setup
- All calendars are stored in dedicated directories in `~/.local/share/calendar/`
- Each event is stored in a separate `ics` file
- A mirror of the calendars are maintained in `~/.local/share/calendar_singlefile/`, where all events of a calendar are aggregated in a single `ics` file
- vdirsyncer synchronizes the normal and single-file calendars with the NC's CalDAV

## Clients
- ikhal/khal: console calendar
    - Has no nice week overview
    - Easy to script
    - Cannot delete a single instance of a repeated event
    - Accesses calendar files in `~/.local/share/calendar/`

- gnome-calendar:
    - Has a nice graphical week overview
    - Can delete a single instance of a repeated event
    - Accesses calendar files in `~/.local/share/calendar_singlefile/`
    - Is configured via Evolution

## Create new Calendar
1. Create calendar in NC
2. Run `vdirsyncer discover` and tell it to create new folders/files for the calendar
3. Add calendar in `~/.config/khal/config`
4. Open evolution
    a. Right-Click *On This Computer* -> *New Calendar*
    b. Enter the following into the form:
        - Type: On This Computer
        - Use existing iCalendar (ics) files: True
        - File: Select appropriate file in `~/.local/share/calendar_singlefile/`
5. Done

