# Calibrate Monitor

## Steps

- Create new `.icc` profile using DisplayCAL

  - Reset current profile: `Tools -> Video Card Gamma Table -> Reset Video Card Gamma Table`
  - Select Settings `Default (Gamma 2.2)`
  - Display & Instrument
    - Display
      - Select correct display
      - Untick everything
      - Output levels `Full Range RGB 0-255`
      - Correction `Auto (None)`
    - Instrument
      - Select correct instrument
      - Untick everything
      - Select Instrument mode `LCD (generic)`
  - Calibration
    - (Optional) Enable `Ambinet light level adjustment`
      - Determine value using instrument (generally between 120 - 180)
  - Profiling
    - Enable `Black Point Compensation`
  - Connect instrument
  - Check if instrument detected by pressing on `Display & Instrument ->` Arrow cycle
  - Disable display sleep `xset s off && xset -dpms`
  - Disable redshift
  - Start by clicking `Callibrate & Profile`
  - Make sure display has right settings
    - `Start Mesure`
      - Make sure brightness and colors of monitor are good
      - Disable again
  - `Continue on to callbiration`

- Copy profile form `~/.local/share/DisplayCAL/storage/<somePath>/<someFile>.icc` to `/usr/share/color/icc/colord/` (tried `~/.local/share/icc/` but somehow did not work)
- Run `systemctl restart colord` to make colord find new profiles
- Start `xiccd` and let it run
- Figure out `Device ID` from `colormgr get-devices` of desired monitor
- Figure out `Profile ID` from `colormgr get-profiles` of desired profile
- Search for profile `colormgr find-profile-by-filename <ProfileID>`
- Add profile to monitor `colormgr device-add-profile <DeviceID> <ProfileID>`
- Set profile as default for monitor `colormgr device-make-profile-default <DeviceID> <ProfileID>`
- Quit `xiccd`
- Check that profile has successfully been loaded: `xprop -display :0.0 -len 14 -root _ICC_PROFILE`

- Really good article about the matter: <https://web.archive.org/web/20221226110150/https://encrypted.pcode.nl/blog/index.html%3Fp=853.html>
